#ifndef SEARCHPANEL_H
#define SEARCHPANEL_H

#include <QWidget>

class QLineEdit;
class ClearLineEdit;

class SearchPanel : public QWidget
{
    Q_OBJECT
public:
    explicit SearchPanel(QWidget *parent = 0);
    bool caseSensitive() const {return m_caseSensitive;}
    bool wholeWord() const {return m_wholeWord;}
    bool useRegularExpressions() const {return m_useRegularExpressions;}
    void startSearch(const QString &searchWhat);
    const QString replaceBy();
    const QString searchWhat();
signals:
    void find(const bool forward);
    void replaceAll();
    void replace();
    void replaceAndFind();
public slots:
private slots:
    void setCaseSensitive(bool);
    void setWholeWord(bool);
    void setRegularExpressions(bool);
    void findNext();
    void findPrev();
private:
    void findFlagsChanged();
    QPixmap pixmapForFindFlags();
    ClearLineEdit *searchWhatEdit;
    ClearLineEdit *replaceByEdit;
    bool m_caseSensitive;
    bool m_wholeWord;
    bool m_useRegularExpressions;
};

#endif // SEARCHPANEL_H
