/**
 * \file tagrender.h
 * Renders tags from placeholders.
 *
 * \b Project: Qoobar
 * \author Alex Novichkov
 * \date 31 Dec 2010
 *
 * Copyright (C) 2010  Alex Novichkov
 *
 * This file is part of Qoobar.
 *
 * Qoobar is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Qoobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TAGRENDER_H
#define TAGRENDER_H

#include <QStringList>

class Tag;
class Model;
//#include "stringroutines.h"

class SimpleTagsRenderer
{
public:
    SimpleTagsRenderer(Model *model)
        : m(model) {    }
    QStringList getNewTags() {updateTags(); return newTags;}
    virtual ~SimpleTagsRenderer() {}

    void setPattern(const QString &pattern) {m_pattern = pattern; updateTags();}
    virtual void updateTags();
    virtual void preprocess();
    virtual void postprocess();
    QString m_pattern;
    QStringList newTags;
    Model *m;
};

class FileNameRenderer: public SimpleTagsRenderer
{
public:
    FileNameRenderer(Model *model)
        : SimpleTagsRenderer(model) {    }
    QStringList getPrefixes() {return prefixes;}
    virtual ~FileNameRenderer() {}
private:
    virtual void updateTags();
    virtual void preprocess();
    QStringList prefixes;
};

#endif // TAGRENDER_H
